import { EventEmitter } from '@angular/core';
import { NgxSuperSelectOptions } from './ngx-super-select-options';
import { ControlValueAccessor } from '@angular/forms';
import { NgxSuperSelectService } from './ngx-super-select.service';
import * as i0 from "@angular/core";
export declare class NgxSuperSelectComponent implements ControlValueAccessor {
    private ngxSuperSelectService;
    private _onTouch;
    private _onChange;
    writeValue(obj: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState?(isDisabled: boolean): void;
    onDocumentClicked(): void;
    dataSource: any;
    disabled: boolean;
    _options: NgxSuperSelectOptions;
    set options(value: Partial<NgxSuperSelectOptions>);
    get options(): NgxSuperSelectOptions;
    /**
     * the list of the selected values
     * these values get checked againts valueExpr of the items in dataSource
     * e.g. disabledItemValues[0] === dataSource[0][valueExpr]
     */
    selectedItemValues: any;
    /**
     * the list of the disabled item values
     * these values get checked againts valueExpr of the items in dataSource
     * e.g. disabledItemValues[0] === dataSource[0][valueExpr]
     */
    disabledItemValues: any;
    selectionChanged: EventEmitter<any[]>;
    /**
     * The state of the popup
     */
    isOpen: boolean;
    /**
     * the current searched phrase
     */
    searchText: string;
    /**
     * unique id of this instance
     */
    private selectId;
    constructor(ngxSuperSelectService: NgxSuperSelectService);
    /**
     * register this instance for a central control over all instances
     */
    private registerSelect;
    onBoxClicked(e: any): void;
    onItemClicked(e: any, item: any): void;
    onSelectAllClicked(e: any): void;
    onInvertSelectionClicked(e: any): void;
    onClearClicked(e: any): void;
    handleActionButtonEvent(e: any): void;
    onPopupClicked(e: any): void;
    isItemSelected(item: any): boolean | undefined;
    isItemDisabled(item: any): boolean | undefined;
    getFilteredItems(): any[];
    getNameForValue(obj: any): string;
    getName(obj: any): string;
    getValue(obj: any): number;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxSuperSelectComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgxSuperSelectComponent, "ngx-super-select", never, { "dataSource": { "alias": "dataSource"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "options": { "alias": "options"; "required": false; }; "selectedItemValues": { "alias": "selectedItemValues"; "required": false; }; "disabledItemValues": { "alias": "disabledItemValues"; "required": false; }; }, { "selectionChanged": "selectionChanged"; }, never, never, false, never>;
}
